﻿// Spore API Sample
// www.sporeapi.com
package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.text.*;	
	import flash.geom.*;
	
	// This class holds an asset
	// It handles the loading of the asset PNG
	// It also has an Update Loop that makes the asset fall
	public class Hoverer extends MovieClip {  	
		
		public var mId:String;
		public var mApp:SporeWebTest;
		public var mSpawnPoint:Point;
		public var mLoading:Boolean;
		public var mLoaded:Boolean;
		public var mSpeed;
		public var mDirection;
		public var mSmallPNG;
		public var mFace;

		
		public function Hoverer(app:SporeWebTest, id:String, spawn:Point, speed:Number):void
		{
			
			this.buttonMode = true;
			this.useHandCursor = true;
			this.mouseEnabled = true;
			addEventListener(MouseEvent.ROLL_OVER, mouseOver);
			addEventListener(MouseEvent.ROLL_OUT, mouseOut);
			addEventListener(MouseEvent.CLICK, clicked);mApp = app;
			mId = id;
			mSpawnPoint = spawn;
			mSpeed = (Math.random() * .3 +.1)
			this.x = mSpawnPoint.x;
			this.y = mSpawnPoint.y;
			mLoaded = false;
			mLoading = false;
			addEventListener(Event.ENTER_FRAME, Update);
			mDirection = 1;
			mFace = 1;
		}
		
		public function LoadPNG()
		{
			mLoading = true;
			mLoaded = false;
			GetSmallPNG(mId);
		}
		
		// Get small 128x128 PNG from asset ID
		public function GetSmallPNG(assetId:String):void
		{
			var subId1:String = assetId.substr(0,3);
			var subId2:String = assetId.substr(3,3);
			var subId3:String = assetId.substr(6,3);
			var smallPNGURL = "http://www.spore.com/static/thumb/"+subId1+"/"+subId2+"/"+subId3+"/"+assetId+".png"
			var smallPNGLoader:Loader = new Loader();
			smallPNGLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, GotSmallPNG);
			smallPNGLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, HandleSmallPNGError);
			smallPNGLoader.load(new URLRequest(smallPNGURL));
		}
		
		public function HandleSmallPNGError(e:IOErrorEvent):void
		{
			trace(e.text);
		}
		
		// Show the assets
		public function GotSmallPNG(e:Event):void
		{
			var smallPNG:Bitmap = e.target.content;
			smallPNG.smoothing = true;
			addChild(smallPNG);
			smallPNG.scaleX*=-1;
			mSmallPNG = smallPNG;
			mLoaded = true;
			mLoading = false;		
			if(this.x >= 335)
			{
				mSmallPNG.scaleX*=-1;
			}
		}	
		
		public function Update(e:Event):void
		{
			if(mLoaded)
			
				{
				if(mDirection == 1)
				{
					this.y+= mSpeed;
					if(this.y >= 275)
					{
						mDirection = 2;
					}
				}
				else
				{	
					this.y-= mSpeed;
				}
				
				if(this.y <=  85)
				{
					mDirection = 1;

				}
				
			}
			
			
			
			
			
			//{
//				this.y+= mSpeed;
//				if(this.y > mApp.mHeight)
//				{
//					this.y = -Math.random() * 0;
//				}
//			}
		}
		public function clicked(e:MouseEvent) :void{ 
		navigateToURL(new URLRequest("http://www.spore.com/sporepedia#qry=sast-"+mId+""), '_blank');
		}
		
		public function mouseOver(e:MouseEvent):void{
		}
		
		
		
		public function mouseOut(e:MouseEvent):void{
		}

	}
}